<template>

  <Head>
    <title>Users - GreenK Cashier</title>
  </Head>
  <main class="c-main">
    <div class="container-fluid">
      <div class="fade-in">
        <div class="row">
          <div class="col-md-12">
            <div class="card border-0 rounded-3 shadow">
              <div class="card-header bg-primary text-white">
                <span class="font-weight-bold"><i class="fa fa-users me-2"></i> USERS</span>
              </div>
              <div class="card-body">
                <div class="row">
                  <!-- link view create user -->
                  <div class="col-md-6 mb-2 mb-md-0">
                    <Link href="/apps/users/create" v-if="hasAnyPermission(['users.create'])"
                      class="btn btn-primary input-group-text"> <i class="fa fa-plus-circle me-2"></i> Create User
                    </Link>

                  </div>
                  <!-- form search -->
                  <div class="col-md-6">
                    <form @submit.prevent="handleSearch">
                      <div class="input-group mb-3">
                        <input type="text" class="form-control" v-model="search" placeholder="Search user...">
                        <button class="btn btn-primary input-group-text" type="submit">
                          <i class="fa fa-search me-2"></i>
                        </button>
                      </div>
                    </form>
                  </div>
                </div>

                <!-- table of users -->
                <div class="table-responsive">
                  <table class="table table-hover">
                    <thead class="bg-primary">
                      <tr>
                        <th scope="col" class="text-center">#</th>
                        <th scope="col">Full Name</th>
                        <th scope="col">Email Address</th>
                        <th scope="col">Roles</th>
                        <th scope="col" style="width:20%" class="text-center">Actions</th>
                      </tr>
                    </thead>
                    <tbody>
                      <tr v-for="(user, index) in users.data" :key="index">
                        <td class="fw-bold text-center">
                          {{ ++index + (users.current_page - 1) *
                          users.per_page }}
                        </td>
                        <td>{{ user.name }}</td>
                        <td>{{ user.email }}</td>
                        <td>
                          <span v-for="(role, index) in user.roles" :key="index"
                            class="badge badge-primary shadow border-0 ms-2 mb-2">
                            {{ role.name }}
                          </span>
                        </td>
                        <td class="text-center">
                          <!-- link view edit -->
                          <Link :href="`/apps/users/${user.id}/edit`" v-if="hasAnyPermission(['users.edit'])"
                            class="btn btn-info btn-sm mb-md-0 mx-1 mb-2 mb-sm-0"><i
                            class="fa fa-pencil-alt text-white fa-fw"></i>
                          </Link>
                          <!-- button delete -->
                          <button @click.prevent="destroy(user.id)" v-if="hasAnyPermission(['users.delete'])"
                            class="btn btn-danger btn-sm mx-1">
                            <i class="fa fa-trash fa-fw"></i>
                          </button>
                        </td>

                      </tr>
                    </tbody>
                  </table>
                </div>
                <Pagination :links="users.links" align="end" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </main>
</template>

<script>
// import layout
import LayoutApp from '../../../Layouts/App.vue'

// import component pagination
import Pagination from '../../../Components/Pagination.vue'

// import Heade and Link from Inertia
import { Head, Link } from '@inertiajs/vue3'

// import ref from vue
import { ref } from 'vue'

// import inertia adapter
import { router } from '@inertiajs/vue3'

// import sweetalert2 
import Swal from 'sweetalert2'

export default {
  // layout
  layout: LayoutApp,

  // register component
  components: {
    Head,
    Link,
    Pagination
  },

  // props
  props: {
    users: Object,
  },

  setup() {

    // define state search
    const search = ref('' || (new URL(document.location)).searchParams.get('q'));

    // define method search
    const handleSearch = () => {
      router.get('/apps/users', {

        // send params "q" with value from state "search"
        q: search.value,
      });
    }

    // method destroy 
    const destroy = (id) => {
      Swal.fire({
        title: 'Are you sure?',
        text: "You won't be able to revert this!",
        icon: 'warning',
        showCancelButton: true,
        confirmButtonColor: '#3085d6',
        cancelButtonColor: '#d33',
        confirmButtonText: 'Yes, delete it!'
      })
        .then((result) => {
          if (result.isConfirmed) {

            router.delete(`/apps/users/${id}`);

            Swal.fire({
              title: 'Deleted!',
              text: 'User has been deleted.',
              icon: 'success',
              timer: 2000,
              showConfirmButton: false,
            });
          }
        })
    }
    // return
    return {
      search,
      handleSearch,
      destroy
    }

  }
}
</script>

<style>

</style>